private void NewMethod(FloorType floorType, CurveArray curves, Level level1) { RoomFilter filter = new RoomFilter(); FilteredElementCollector collector = new FilteredElementCollector(_doc); IList <Element> rooms = collector.WherePasses(filter).ToElements(); int n = rooms.Count(); foreach (Room room in rooms) { IList <IList <BoundarySegment> > segments = room.GetBoundarySegments(new SpatialElementBoundaryOptions()); CurveArray roomsCurves = new CurveArray(); // Array to hold curv data collected from room boundreis roomsCurves.Clear(); SpatialElementBoundaryOptions bo = new SpatialElementBoundaryOptions(); SketchPlane sp = _doc.ActiveView.SketchPlane; foreach (IList <BoundarySegment> lstBs in room.GetBoundarySegments(bo)) { foreach (BoundarySegment bs in lstBs) { roomsCurves.Append(bs.GetCurve()); } } _doc.Create.NewFloor(roomsCurves, floorType, level1, false); } //_doc.Create.NewFloor(curves, floorType, level1, true); }
private void CreateModelCurveArray(CurveArray curveArray, XYZ normal, XYZ point) { if (curveArray.Size > 0) { Transaction transaction2 = new Transaction(doc); transaction2.Start("绘制模型线"); try { SketchPlane modelSketch = SketchPlane.Create(doc, app.Create.NewPlane(normal, point)); ModelCurveArray modelLine = doc.Create.NewModelCurveArray(curveArray, modelSketch); } catch { } transaction2.Commit(); curveArray.Clear(); } }
public static Dictionary <string, object> ByRoom(string familyTemplatePath, global::Revit.Elements.Room room, string materialName, global::Revit.Elements.Category category, string subcategory = "") { //variables global::Revit.Elements.Element famInstance = null; Autodesk.Revit.DB.FamilyInstance internalFam = null; bool fileFound = false; //the current document Autodesk.Revit.DB.Document doc = DocumentManager.Instance.CurrentDBDocument; UIApplication uiapp = new UIApplication(doc.Application); //convert the room to an Autodesk.Revit.DB representation Autodesk.Revit.DB.Architecture.Room internalRoom = (Autodesk.Revit.DB.Architecture.Room)room.InternalElement; string name = internalRoom.Name; //we close all of the families because we need to swap documents foreach (Document d in uiapp.Application.Documents) { if (d.IsFamilyDocument) { d.Close(false); } } //create the new family document in the background and store it in memory Document familyDocument = uiapp.Application.NewFamilyDocument(familyTemplatePath); //instantiate a material element id and try to get the material that was specified ElementId material = null; FilteredElementCollector materialCollector = new FilteredElementCollector(familyDocument).OfClass(typeof(Autodesk.Revit.DB.Material)); foreach (var m in materialCollector) { if (m.Name.ToLower().Replace(" ", "") == materialName.ToLower().Replace(" ", "")) { material = m.Id; } } //close Dynamo's open transaction, we need to do this because we open a new Revit API transaction in the family document (This is document switching) TransactionManager.Instance.ForceCloseTransaction(); //start creating the families. Transaction trans = new Transaction(familyDocument, "Generate Families Ya'll"); trans.Start(); //set the family category Autodesk.Revit.DB.Category familyCategory = familyDocument.Settings.Categories.get_Item(category.Name); familyDocument.OwnerFamily.FamilyCategory = familyCategory; //get the subcategory for the solids Autodesk.Revit.DB.Category subCategory = null; foreach (Autodesk.Revit.DB.Category c in familyCategory.SubCategories) { if (c.Name.ToLower() == subcategory.ToLower()) { subCategory = c; } } //get the height of the thing double height = room.Height; //get the curves IList <IList <BoundarySegment> > boundary = internalRoom.GetBoundarySegments(new SpatialElementBoundaryOptions()); //generate a plane Autodesk.Revit.DB.Plane revitPlane = Autodesk.Revit.DB.Plane.CreateByNormalAndOrigin(Vector.ZAxis().ToXyz(), new XYZ(0, 0, 0)); Autodesk.Revit.DB.SketchPlane sketchPlane = SketchPlane.Create(familyDocument, revitPlane); //the curve arrays to generate solids and voids in family CurveArray curveArray = new CurveArray(); CurveArrArray curveArrArray = new CurveArrArray(); CurveArray curveArrayVoid = new CurveArray(); CurveArrArray curveArrArrayVoid = new CurveArrArray(); //to perform the cut action on the solid with the voids CombinableElementArray ceArray = new CombinableElementArray(); //transform bizness Point roomCentroid = room.BoundingBox.ToCuboid().Centroid(); Point locationPoint = Point.ByCoordinates(roomCentroid.X, roomCentroid.Y, 0); CoordinateSystem oldCS = CoordinateSystem.ByOrigin(locationPoint); CoordinateSystem newCS = CoordinateSystem.ByOrigin(0, 0, 0); //flag to step through the boundaries. int flag = 0; while (flag < boundary.Count) { //the first set of curves is the solid's boundary if (flag == 0) { //generate the solid form which is the first item in the boundary segments. foreach (BoundarySegment b in boundary[flag]) { Autodesk.DesignScript.Geometry.Curve c = b.GetCurve().ToProtoType(); Autodesk.DesignScript.Geometry.Curve movedCurve = c.Transform(oldCS, newCS) as Autodesk.DesignScript.Geometry.Curve; curveArray.Append(movedCurve.ToRevitType()); } curveArrArray.Append(curveArray); Extrusion solidExtrusion = familyDocument.FamilyCreate.NewExtrusion(true, curveArrArray, sketchPlane, height); if (material != null) { //Set the material Autodesk.Revit.DB.Parameter matParam = solidExtrusion.get_Parameter(BuiltInParameter.MATERIAL_ID_PARAM); matParam.Set(material); } //try to set the subcategory if (subCategory != null) { solidExtrusion.Subcategory = subCategory; } } //subsequent lists of curves are representative of the voids else { //clear the curves from the collection for all items after the second one. (index 2+) if (!curveArrayVoid.IsEmpty) { curveArrayVoid.Clear(); curveArrArrayVoid.Clear(); ceArray.Clear(); } //generate the void form foreach (BoundarySegment b in boundary[flag]) { Autodesk.DesignScript.Geometry.Curve c = b.GetCurve().ToProtoType(); Autodesk.DesignScript.Geometry.Curve movedCurve = c.Transform(oldCS, newCS) as Autodesk.DesignScript.Geometry.Curve; curveArrayVoid.Append(movedCurve.ToRevitType()); } curveArrArrayVoid.Append(curveArrayVoid); Extrusion voidExtrusion = familyDocument.FamilyCreate.NewExtrusion(false, curveArrArrayVoid, sketchPlane, height); //try to combine things foreach (Extrusion genericForm in new FilteredElementCollector(familyDocument).OfClass(typeof(Extrusion)) .Cast <Extrusion>()) { ceArray.Append(genericForm); } //to add the void to the solid familyDocument.CombineElements(ceArray); } flag++; } familyDocument.Regenerate(); trans.Commit(); Autodesk.Revit.DB.Family fam = null; //build the temporary path string familyFilePath = Path.GetTempPath() + name + ".rfa"; SaveAsOptions opt = new SaveAsOptions(); opt.OverwriteExistingFile = true; familyDocument.SaveAs(familyFilePath, opt); familyDocument.Close(false); TransactionManager.Instance.ForceCloseTransaction(); Transaction trans2 = new Transaction(doc, "Attempting to place or update Room family instances."); trans2.Start(); IFamilyLoadOptions loadOptions = new FamilyImportOptions(); bool variable = true; loadOptions.OnFamilyFound(true, out variable); doc.LoadFamily(familyFilePath, loadOptions, out fam); FamilySymbol familySymbol = (FamilySymbol)doc.GetElement(fam.GetFamilySymbolIds().First()); //try to find if it is placed already FilteredElementCollector col = new FilteredElementCollector(doc); //get built in category from user viewable category BuiltInCategory myCatEnum = (BuiltInCategory)Enum.Parse(typeof(BuiltInCategory), category.Id.ToString()); foreach (Autodesk.Revit.DB.Element e in col.WhereElementIsNotElementType().OfCategory(myCatEnum).ToElements()) { Autodesk.Revit.DB.FamilySymbol type = (FamilySymbol)doc.GetElement(e.GetTypeId()); if (type.FamilyName.Equals(name)) { fileFound = true; internalFam = e as Autodesk.Revit.DB.FamilyInstance; } } //place families that are not placed if (fileFound == false) { if (!familySymbol.IsActive) { familySymbol.Activate(); } internalFam = doc.Create.NewFamilyInstance(new XYZ(roomCentroid.X, roomCentroid.Y, 0), familySymbol, internalRoom.Level, StructuralType.NonStructural); } trans2.Commit(); //delete the temp file File.Delete(familyFilePath); //cast to Dynamo type for output and location updating (if necessary) famInstance = internalFam.ToDSType(true); if (fileFound) { famInstance.SetLocation(locationPoint); } //returns the outputs var outInfo = new Dictionary <string, object> { { "familyInstance", famInstance } }; return(outInfo); }
public static List <List <DynamoRevitElements.Floor> > CreateRevitFloors( DynamoElements.Surface[][] srfList, DynamoRevitElements.FloorType floorType, string levelPrefixStr = "Dynamo Level") { if (srfList == null) { throw new ArgumentNullException(nameof(srfList)); } if (!(floorType.InternalElement is RevitElements.FloorType revitFloorType)) { throw new ArgumentOutOfRangeException(nameof(floorType)); } DisplayUnitType unitType = Document.GetUnits().GetFormatOptions(UnitType.UT_Length).DisplayUnits; var FloorElements = new List <List <DynamoRevitElements.Floor> >(); var collector = new FilteredElementCollector(Document); var levels = collector.OfClass(typeof(RevitElements.Level)).ToElements() .Where(e => e is RevitElements.Level) .Cast <RevitElements.Level>(); TransactionManager.Instance.EnsureInTransaction(Document); for (var i = 0; i < srfList.Length; i++) { if (srfList[i] == null) { throw new ArgumentNullException(nameof(srfList)); } FloorElements.Add(new List <DynamoRevitElements.Floor>()); string levelName = $"{levelPrefixStr} {i + 1}"; var revitLevel = levels.FirstOrDefault(level => level.Name == levelName); double elevation; using (var floorBounds = BoundingBox.ByGeometry(srfList[i])) { elevation = UnitUtils.ConvertToInternalUnits(floorBounds.MaxPoint.Z, unitType); } if (revitLevel != null) { // Adjust existing level to correct height. revitLevel.Elevation = elevation; } else { // Create new level. revitLevel = RevitElements.Level.Create(Document, elevation); revitLevel.Name = levelName; } var revitCurves = new CurveArray(); foreach (var surface in srfList[i]) { var loops = Building.GetSurfaceLoops(surface); revitCurves.Clear(); loops[0].Curves().ForEach(curve => revitCurves.Append(curve.ToRevitType())); var revitFloor = Document.Create.NewFloor(revitCurves, revitFloorType, revitLevel, true); FloorElements.Last().Add(revitFloor.ToDSType(false) as DynamoRevitElements.Floor); // Need to finish creating the floor before we add openings in it. TransactionManager.Instance.ForceCloseTransaction(); TransactionManager.Instance.EnsureInTransaction(Document); loops.Skip(1).ToArray().ForEach(loop => { revitCurves.Clear(); loop.Curves().ForEach(curve => revitCurves.Append(curve.ToRevitType())); Document.Create.NewOpening(revitFloor, revitCurves, true); }); loops.ForEach(x => x.Dispose()); revitFloor.Dispose(); } revitCurves.Dispose(); } TransactionManager.Instance.TransactionTaskDone(); collector.Dispose(); return(FloorElements); }